
(********************************************************************
  module ListZipper
    zipper for a list
 ********************************************************************)

type 'a list_sublist = 'a list
type 'a list_context = 'a list
type 'a list_zipper  = 'a list_context * 'a list_sublist

(* moving operations *)
let lz_prev = fun (c::prevs, nexts) -> (prevs, c::nexts)
let lz_next = fun (prevs, c::nexts) -> (c::prevs, nexts)

(* editing operations *)
let lz_get_elem        = fun (prevs, c::nexts) ->  c
let lz_set_elem c      = fun (prevs, _::nexts) -> (prevs, c::nexts)
let lz_remove_elem     = fun (prevs, _::nexts) -> (prevs, nexts)
let lz_insert_after  c = fun (prevs,nexts)     -> (prevs, c::nexts)
let lz_insert_before c = fun (prevs,nexts)     -> (c::prevs, nexts)

(* convert a list_zipper and a list *)
let lz_of_list = fun lst            -> ([], lst)
let list_of_lz = fun (prevs, nexts) -> List.rev_append prevs nexts
